#include <iostream.h>


#define L 256/sizeof(int)

struct Set {int data[L];};

void init (Set& s)
{
	for (int i=0; i<L; i++) s.data[i]=0;
}

void incl (Set& s, int e)
{
	s.data[e/sizeof(int)]|=1<<e%sizeof(int);
}

void excl (Set& s, int e)
{
	s.data[e/sizeof(int)]&=~(1<<e%sizeof(int));
}

int in (const Set& s, int e)
{
	return s.data[e/sizeof(int)]&1<<e%sizeof(int);
}
	
void out (const Set &s)
{
	int card=0;
	cout << '[';
	for (int i=0; i<256; i++)
		if (in(s, i)) { if (card++>0) cout<<','; cout<<i; }
	cout << ']';
}

Set intersect (const Set& s1, const Set& s2)
{
	Set l;
	for (int i=0; i<L; i++) l.data[i]=s1.data[i]&s2.data[i];
	return l;
}

Set unite (const Set& s1, const Set& s2)
{
	Set l;
	for (int i=0; i<L; i++) l.data[i]=s1.data[i]|s2.data[i];
	return l;
}


int main()
{
	Set s;
	init (s);
	Set t;
	init (t);
	incl(s, 13);
	incl(s, 137);
	incl(t, 12);
	incl(t, 13);
	incl(t, 14);
	out (s);
	out (t);

	out (intersect(s, t));
	out (unite    (s, t));

}
	
