#include <iostream.h>

extern "C" double sqrt (double);
extern "C" double acos (double);

const double pi=3.14159265358979323846;

class Dreieck {
	double a, b, c;
	static double calc(double x, double y, double z);
public:
	static int check(double, double, double);
	Dreieck(double pa, double pb, double pc);
	double umfang();
	double flaeche();
	double alpha();
	double beta();
	double gamma();
};

Dreieck::Dreieck(double pa, double pb, double pc): a(pa), b(pb), c(pc){}

int Dreieck::check(double a, double b, double c)
{
	if ((a+b<=c)||(a+c<=b)||(b+c<=a)) return 0;
	else return 1;
}

inline double Dreieck::umfang()
{
	return a+b+c;
}

inline double Dreieck::flaeche()
{
	double s=umfang()/2;
	double h=s;

	h*=s-a;
	h*=s-b;
	h*=s-c;

	return sqrt(h);
}

inline double Dreieck::calc(double x, double y, double z)
{
	return 180*(acos((x*x+y*y-z*z)/(2*x*y)))/pi;
}

inline double Dreieck::alpha()
{
	return calc (b, c, a);
}

inline double Dreieck::beta()
{
	return calc (a, c, b);
} 

inline double Dreieck::gamma()
{
	return calc (a, b, c);
}

int main() {

   double a, b, c;
   while(1) {

	cout<<"a = "; cin>>a;
	cout<<"b = "; cin>>b;
	cout<<"c = "; cin>>c;
	
	if (Dreieck::check(a, b, c)) {

	Dreieck d(a,b,c);

	cout	<<"Umfang  = "<<d.umfang()<<"\n"
	    	<<"Flaeche = "<<d.flaeche()<<"\n"
		<<"alpha   = "<<d.alpha()<<"\n"
		<<"beta    = "<<d.beta()<<"\n"
		<<"gamma   = "<<d.gamma()<<"\n";
	}
	else cout << "\n es ist kein Dreieck\n";
   }
}

