#include <iostream.h>

#ifdef HAS_NO_BOOL
typedef int bool;
const true=1;
const false=0;
#endif

class Date {
		int yy, mm, dd;
		static int days_per_month(int month, int year);
		static int dpm[];
		static const char* Month_de[];
		static const char* Month_us[];
		static const char* tag_us(int day);
		static bool leap(int year);
	public:
		Date (int day, int month, int year); // Initialisierung
		enum locale {de,us};
		enum length {Short, Long};
		void print(locale format=de, length l=Short); // de: dd.mm.yy; us: mm/dd/yy
		void next(); // weiterschalten auf den nchsten Tag,
		// yy ist Schaltjahr, wenn durch 4 teilbar, kein Schaltjahr, wenn
		// durch 100 teilbar, aber wiederum Schaltjahr wenn durch 400 teilbar
};

Date::Date(int day, int month, int year):dd(day),mm(month),yy(year){}

const char* Date::tag_us(int day)
{
	if (day==1) return "st";
	if (day==2) return "nd";
	if (day==3) return "rd";
	return "th";
}

void Date::print(locale format, length l)
{
	if (l==Short)
	{
		if (format==de)
			cout<<dd<<'.'<<mm<<'.';
		else
			cout<<mm<<'/'<<dd<<'/';
		if (yy%100 < 10) cout<<'0'; 
		cout<<yy%100;
	}
	else
	{
		if (format==de)
			cout<<dd<<". "<<Month_de[mm-1]<<' ';
		else
			cout<<Month_us[mm-1]<<", "<<dd<<tag_us(dd)<<' ';
		cout<<yy;
	}
}

int Date::dpm[]={31,28,31,30,31,30,31,31,30,31,30,31};

const char* Date::Month_de[]={
				"Januar", "Februar", "Mrz",
				"April", "Mai", "Juni", "Juli",
				"August", "September", "Oktober",
				"November", "Dezember"
			     };

const char* Date::Month_us[]={
				"january", "february", "march",
				"april", "may", "june", "july",
				"august", "september", "october",
				"november", "december"
			     };

int Date::days_per_month(int month, int year)
{
	if (month==2 && leap(year)) return 29;
	return dpm[month-1];
}
	
void Date::next()
{
	if (++dd > days_per_month(mm, yy))
	{
		dd=1;
		if (++mm > 12) {mm=1; ++yy;}
	}
}

bool Date::leap(int year)
{
	if (year%4) return false;
	if (!(year%100)) 
		if (year%400) 
			return false;
	return true;
}

int main()
{
	Date d (1,1,1998);

	int i=1000;
	while(i--) {d.print(Date::de, Date::Long); cout<<endl; d.next();}
}
		
		
