#include <iostream>
#include <cstdlib>

class Euro;
class DM {
	static const double inEuro=1.95583;
	int mark, pfennig;
public:
	DM(int m, int p):mark(m), pfennig(p){}
	DM(double d):mark(int(d)), pfennig((d-int(d))*100){}
	Euro toEuro();
	void out(){cout<<mark<<','<<pfennig<<" DM";}
};

class Euro {
	int euro, cent; 
	static const double inDM=1/1.95583;
public
	Euro(int e, int c):euro(e), cent(c){}	
	Euro(double d):euro(int(d)), cent((d-int(d))*100){}
	DM toDM();
	void out(){cout<<euro<<','<<cent<<" Euro";}
};


Euro DM::toEuro()
{
	int pf=mark*100+pfennig;
	int ct=10*pf / inEuro;
	if (ct%10 >5) (ct/=10)++;
	else ct/=10;

	Euro ret(ct/100, ct%100);
	return ret;
}

DM Euro::toDM()
{
	int eu=euro*100+cent;
	int pf=10*eu / inDM;
	if (pf%10 >5) (pf/=10)++;
	else pf/=10;

	DM ret(pf/100, pf%100);
	return ret;
}

int main(int argc, char** argv)
{
	if (argc<2) {
		cout<< "usage:\n\teuro\tamount - calculates DM\n"
		       "\tdem\tamount - calculates Euro\n";
		exit(-1);
	}

	if (argv[0][0]=='e') // Euro to DM
	// if (argv[0]=="dem") ....
	{
		double amount=atof(argv[1]);
		Euro e (amount);
		cout << amount <<" Euro = ";
		e.toDM().out(); cout << endl;
		return 0;
	}
	if (argv[0][0]=='d') // DM to Euro
	{
		double amount=atof(argv[1]);
		DM d (amount);
		cout << amount <<" DM = ";
		d.toEuro().out(); cout << endl;
		return 0;
	}
		
	cout<< "usage:\n\teuro\tamount - calculates DM\n"
		       "\tdem\tamount - calculates Euro\n";
	exit(-1);
}
		



