#include <iostream>

using namespace std;

#define PLAY(X) void spiele(){cout << #X " spielt"<<endl;}

class Instrument {
public:
	virtual void stimme() {cout<<"stimmen eines unbekannten Instruments\n";}
	virtual void spiele() {cout<<"spielen eines unbekannten Instruments\n";}
};

class BlasInstrument: public Instrument {
public:
	void stimme(){}
};

class SchlagInstrument: public Instrument {
public:
	void stimme(){}
};

class StreichInstrument: public Instrument {
public:
	void stimme(){cout<<"ein Streichinstrument wird gestimmt"<<endl;}
};

class ZupfInstrument: public Instrument {
public:
	void stimme(){cout<<"ein Zupfinstrument wird gestimmt"<<endl;}
};

class Geige: public StreichInstrument {};

class Trommel: public SchlagInstrument {};

class Triangel: public SchlagInstrument{
public:	PLAY(Triangel);
};

class KleineTrommel: public Trommel {
public:	PLAY(Kleine Trommel);
};

class GrosseTrommel: public Trommel{
public:	PLAY(Grosse Trommel);
};

class Pauke: public SchlagInstrument {
public:	PLAY(Pauke);
};

class Basstuba: public BlasInstrument{
public: PLAY(Basstuba);
};

class Posaune: public BlasInstrument{
public: PLAY(Posaune);
};

class Kontrabass: public StreichInstrument{
public: PLAY(Kontrabass);
};

class Horn: public BlasInstrument{
public: PLAY(Horn);
};

class Fagott: public BlasInstrument{
public: PLAY(Fagott);
};

class Oboe: public BlasInstrument{
public: PLAY(Oboe);
};

class Klarinette: public BlasInstrument{
public: PLAY(Klarinette);
};

class ErsteGeige: public Geige{
public: PLAY(Erste Geige);
};

class ZweiteGeige: public Geige{
public: PLAY(Zweite Geige);
};

class Bratsche: public StreichInstrument{
public: PLAY(Bratsche);
};

class Floete: public BlasInstrument{
public: PLAY(Floete);
};

class Trompete: public BlasInstrument{
public: PLAY(Trompete);
};

class Violoncello: public StreichInstrument{
public: PLAY(Violoncello);
};

class Harfe: public ZupfInstrument{
public: PLAY(Harfe);
};


void main()
{
	Instrument* Orchester[100];

	int n=0;

	// 12 erste Geigen:
	for (int i=0; i<12; ++i) Orchester[n++]=new ErsteGeige;
	
	// 10 zweite Geigen:
	for (int i=0; i<10; ++i) Orchester[n++]=new ZweiteGeige;

	// 8 Violoncelli, 8 Bratschen:
	for (int i=0; i<8; ++i) {
				Orchester[n++]=new Violoncello;
				Orchester[n++]=new Bratsche;
	}

	// 6 Kontrabaesse:
	for (int i=0; i<6; ++i) Orchester[n++]=new Kontrabass;

	// 3 Fagotte, 3 Floeten, 3 Klarinetten:
	for (int i=0; i<3; ++i) {
				Orchester[n++]=new Fagott;
				Orchester[n++]=new Floete;
				Orchester[n++]=new Klarinette;
	}

	// 4 Hoerner:
	for (int i=0; i<4; ++i) Orchester[n++]=new Horn;

	// 3 Trompeten, 3 Posaunen:
	for (int i=0; i<3; ++i) {
				Orchester[n++]=new Trompete;
				Orchester[n++]=new Posaune;
	}

	// 2 Pauken, 2 Grosse Trommeln, 2 Kleine Trommeln:
	for (int i=0; i<2; ++i) {
				Orchester[n++]=new Pauke;
				Orchester[n++]=new KleineTrommel;
				Orchester[n++]=new GrosseTrommel;
	}


	// Basstuba, Harfe, Triangel:
	Orchester[n++]=new Basstuba;
	Orchester[n++]=new Harfe;
	Orchester[n++]=new Triangel;

cout<< n << " Instrumente im Orchester\n";

	for (int i=0; i<n; ++i) Orchester[i]->stimme();
	for (int i=0; i<n; ++i) Orchester[i]->spiele();
	
}

	

