#include "Complex.h"

Complex operator + (const Complex& z1, const Complex& z2)
{
	return Complex(z1.real+z2.real, z1.imag+z2.imag);
}

Complex operator - (const Complex& z1, const Complex& z2)
{
	return Complex(z1.real-z2.real, z1.imag-z2.imag);
}

Complex operator * (const Complex& z1, const Complex& z2)
{
	return Complex(z1.real*z2.real-z1.imag*z2.imag,
		       z1.real*z2.imag+z1.imag*z2.real);
}

Complex operator / (const Complex& z1, const Complex& z2)
{
	double q=z2.real*z2.real + z2.imag*z2.imag;
	if (q==0) { cerr<<"Division durch Null\n"; return z1;}
	double x=z1.real*z2.real+z1.imag*z2.imag;
	double y=z1.imag*z2.real-z1.real*z2.imag;

	return Complex(x/q, y/q);
}

ostream& operator << (ostream& o, const Complex& z)
{
	o<<z.real;
	if (z.imag) o<<"+i*"<<z.imag;
	return o;
}

istream& operator >> (istream& i, Complex& z)
{
	i>>z.real;
	char c;
	i>>c;
	if (c=='+') {
		i>>c>>c; // skip i*
		i>>z.imag;
	}
	else {
		z.imag=0;
		i.putback(c);
	}
	return i;
}
