#include "Vektor.h"
#include <stdlib.h>
#include <iostream.h>


static void vektor_error(const char* s)
{
	cerr<<s<<endl; exit(-1);
}

Vektor::Vektor (int dim): n(dim), data(new double[dim])
{
	for (int i=0; i<dim; ++i) data[i]=0;
}

	 	
Vektor::Vektor (const Vektor& v): n(v.n), data(new double[v.n])
{
	for (int i=0; i<n; ++i) data[i]=v.data[i];
}	
	
double& Vektor::operator[](int ind)
{
	if (n>=0 && ind<n) return data[ind];
	else vektor_error("index out of range");
}	
					
double operator* (const Vektor& v1, const Vektor& v2)
{
	if (v1.n!=v2.n) vektor_error("size does not match in *");
	double s=0;
	for (int i=0; i<v1.n; ++i) s+=v1.data[i]*v2.data[i];
	return s;
}

ostream& operator<<(ostream& o, const Vektor& v)
{	
	o<<'[';
	for(int i=0; i<v.n-1; ++i) o<<v.data[i]<<',';
	return o<<v.data[v.n-1]<<']';
}
	
Vektor& Vektor::operator=(const Vektor& v)
{
	if (this==&v) return *this;
	if (n<=v.n) for (int i=0; i<n; ++i) data[i]=v.data[i];
	else 
	{	int i; /* 1 */
		for (i=0; i<v.n; ++i) data[i]=v.data[i];
		for (i=v.n; i<n; ++i) data[i]=0;
	}
	return *this;
}
			
/* 1 */ 

// some compilers (namely CC) do not conform to the new scoping:
// for (int i= .....) ...; no more i
// for (int i /* a new */= .....) ...; no more i again

