#include <iostream>
#include <ctime>
#include "Timer"

void Timer::err(char*s){
	cerr<<"Timer error: "<<s<<endl;
}

void Timer::start() {
	if (state==running){
		err("already running");
		return;
	}
	state=running;	
	micros=clock();
}

void Timer::stop() {
	if (state==stopped){
		err("already stopped");
		return;
	}
	state=stopped;	
	micros=clock()-micros;
}

double Timer::millisec(){
	if (state==running) {
		err("yet running");
		return 0;
	}
	return micros/1000.0;
}

double Timer::sec(){
	return millisec()/1000.0;
}

