#include <set>
#include <iostream>
#include <string>

using namespace std;

typedef set<const class Land*> Laender;
typedef Laender::iterator It;

class Land {
public:
	string Landesname;
	string Hauptstadt;

	Laender nachbarn;
	void Nachbar(Land& l) {nachbarn.insert(&l);}

public:
	Land (string n, string h):
		Landesname(n), Hauptstadt(h) {}
	Land(const Land&); // keine Kopien bitte !

	friend void Grenze (Land& l1, Land& l2)
	{
		l1.Nachbar(l2);
		l2.Nachbar(l1);
	}
	
	friend int main();

	void druckeNachbarn() 
	{
		for(It i=nachbarn.begin(); 
			i !=nachbarn.end(); ++i  )
				cout<<"\t"<<(*i)->Landesname<<endl;
	}

	friend int Distanz (const Land& von, const Land& nach);

	bool operator==(const Land& o) const {return this==&o;}
};

void druckeLaender(Laender& l)
{
	for(It i=l.begin(); i !=l.end(); ++i  )
		cout<<"\t"<<(*i)->Landesname<<endl;
}


int Distanz (const Land& von, const Land& nach)
{
	if (von==nach) return 0;
	
	int dist=1;

	Laender rundherum=von.nachbarn;

	while (rundherum.find(&nach)==rundherum.end())
	{	// bisher nicht gefunden

		Laender vorher=rundherum;

cout<<"vorher:\n";
druckeLaender(vorher);

		++dist;
		for (It i=vorher.begin();
			i!=vorher.end(); ++i)
		{
			for (It j=(*i)->nachbarn.begin();
				j!=(*i)->nachbarn.end(); ++j)
			{
				cout<< "nehme auf: "<<(*j)->Landesname<<endl;
				rundherum.insert(*j);
			}
		}

cout<<"nachher:\n";
druckeLaender(rundherum);

		if (vorher==rundherum) return -1;	
			
	}
	// gefunden
	return dist;
}
	
int main()
{
	Land Deutschland ("Deutschland", "Berlin"   );
	Land Polen       ("Polen"      , "Warschau" );
	Land Tschechien  ("Tschechien" , "Prag"     ); 
	Land Oesterreich ("Oesterreich", "Wien"     );
	Land Holland     ("Holland"    , "Amsterdam");
	Land& Niederlande = Holland;
	Land Frankreich  ("Frankreich" , "Paris"    );
	Land Belgien     ("Belgien"    , "Den Haag" );
	Land Schweiz     ("Schweiz"    , "Bern"     );
	Land Russland    ("Russland"   , "Moskau"   );
	Land Portugal    ("Portugal"   , "Lissabon" );
	Land Finnland    ("Finnland"   , "Helsinki" );
	Land Spanien     ("Spanien"    , "Madrid"   );
	Land Italien     ("Italien"    , "Rom"      );
	Land Norwegen    ("Norwegen"   , "Oslo"     );
	Land Schweden    ("Schweden"   , "Stockholm");

	Grenze(Deutschland, Polen);
	Grenze(Deutschland, Tschechien);
	Grenze(Deutschland, Oesterreich);
	Grenze(Deutschland, Holland);
	Grenze(Deutschland, Frankreich);
	Grenze(Deutschland, Belgien);
	Grenze(Deutschland, Schweiz);

	Grenze(Tschechien, Polen);
	Grenze(Russland, Polen);
	Grenze(Russland, Finnland);
	Grenze(Spanien, Frankreich);
	Grenze(Spanien, Portugal);

	Grenze(Tschechien, Oesterreich);
	Grenze(Italien, Frankreich);
	Grenze(Italien, Schweiz);
	Grenze(Italien, Oesterreich);
	Grenze(Spanien, Frankreich);
	Grenze(Spanien, Portugal);


//	cout<<Distanz(Holland, Niederlande)<<endl;
//	cout<<Distanz(Deutschland, Russland)<<endl;
	cout<<Distanz(Portugal, Finnland)<<endl;

}
		
	
