#include <cstdio>
#include <list>
using std::list;
using std::printf;

class Country{
    list<Country*> neighbors;
    char *name;
    static int count;
  public:
    Country(char* name);
    void travel_to(Country *dest,int cur, int &max);
    // friends
    friend int Border(Country&, Country&);
    friend void travel(Country& from, Country& to);
};

int Country::count=0;

Country::Country(char *n):name(n)
{
  count++;
}

void Country::travel_to(Country *dest,int cur,int &max)
{
  if(dest==this){
    max = cur;
    return;
  }
  if(cur==max)
    return;
  for(list<Country*>::iterator it=neighbors.begin();
      it!=neighbors.end();it++)
    (*it)->travel_to(dest, cur+1, max);
}

int Border(Country& from,Country& to)
{
  static int i=0;
  printf("%d:%s %s\n",++i,from.name,to.name);
  from.neighbors.push_back(&to);
  to.neighbors.push_back(&from);
  return 0;
}

void travel(Country& from, Country& to)
{
  int max = Country::count+1;
  from.travel_to(&to, 0, max);
  if (max == Country::count+1)
    printf("No way from %s to %s\n",from.name,to.name);
  else
    printf("From %s to %s: %d borders\n",
           from.name,to.name,max);
}

#define C(X,F)      Country F(#X)
#define B(X,Y)    int X##Y = Border(X,Y);int Y##X 

// der compiler entdeckt doppelt erfasste grenzen !!

C(Russland,ru);
C(Estland,ee);
C(Lettland,lt);
C(Litauen,lv);
C(Belarus,by);
C(Ukraine,ua);
C(Moldawien,md);
C(Polen,pl);
C(Slowakei,sk);
C(Ungarn,hu);
C(Rumaenien,ro);
C(Bulgarien,bg);
C(Mazedonien,mk);
C(Griechenland,gr);
C(Tuerkei,tr);
C(Tschechien,cz);
C(Oesterreich,at);
C(Slovenien,si);
C(Kroatien,hr);
C(Bosnien,ba);
C(Jugoslawien,yu);
C(Albanien,al);
C(Deutschland,de);
C(Schweiz,ch);
C(Italien,it);
C(Frankreich,fr);
C(Andorra,ad);
C(Spanien,es);
C(Portugal,pt);
C(Finnland,fi);
C(Schweden,se);
C(Norwegen,no);
C(Island,is);
C(Daenemark,dk);
C(Grossbritannien,uk);
C(Irland,ie);
C(Niederlande,nl);
C(Belgien,be);
C(Luxemburg,lu);

B(pt,es);
B(es,fr);B(es,ad);
B(ad,fr);
B(fr,it);B(fr,ch);B(fr,de);B(fr,lu);B(fr,be);
B(ie,uk);
B(be,nl);B(be,de);B(be,lu);
B(lu,de);
B(nl,de);
B(de,dk);B(de,pl);B(de,cz);B(de,at);B(de,ch);
B(ch,it);
B(it,at);
B(at,cz);B(at,sk);B(at,hu);B(at,si);
B(cz,pl);B(cz,sk);
B(pl,ru); // russland ist nicht zusammenhaengend --> u.u. fehler

B(pl,by);B(pl,ua);B(pl,sk);
B(sk,ua);B(sk,hu);
B(si,hu);B(si,hr);
B(hr,hu);B(hr,yu);B(hr,ba);
B(ba,yu);
B(yu,al);B(yu,mk);B(yu,bg);B(yu,ro);B(yu,hu);
B(al,gr);B(al,mk);
B(gr,mk);B(gr,bg);B(gr,tr);
B(bg,ro);
B(ro,hu);B(ro,ua);B(ro,md);
B(hu,ua);
B(ua,md);B(ua,ru);B(ua,by);
B(by,lt);B(by,lv);B(by,ru);
B(lt,ru);B(lt,lv);
B(lv,ru);B(lv,ee);
B(ee,ru);
B(no,se);B(no,fi);B(no,ru);
B(se,fi);

int main()
{
  travel(pl,tr);
}
