#include <iostream>
#include <cassert>

using namespace std;

class Geldbetrag {
	int mark, pfennig;
public:
	Geldbetrag(unsigned int m, unsigned int p):
		mark(m), pfennig(p){assert(m>=0);
				    assert(p>=0); assert(p<100);}

	friend ostream& operator << (ostream& o, const Geldbetrag& g)
		{
			o<<g.mark<<',';
			if (g.pfennig<10) o<<0;
			return o<<g.pfennig<<" DM";
		}
	operator int() const {return 100*mark+pfennig;}
};

class Z {// Zahlungsmittel
public:
	virtual int nominal()=0;	// in pfennig
};

class Muenze:public virtual Z{};
class Schein:public virtual Z{};

class Pfennig:public Muenze {int nominal(){return 1;}};
class Zweier:public Muenze {int nominal(){return 2;}};
class Fuenfer:public Muenze {int nominal(){return 5;}};
class Groschen:public Muenze {int nominal(){return 10;}};
class Fuenfziger:public Muenze {int nominal(){return 50;}};
class Mark:public Muenze {int nominal(){return 100;}};
class ZweiMark:public Muenze {int nominal(){return 200;}};
class FuenfMark: public Muenze, 
		 public Schein {int nominal(){return 500;}};

class ZehnMark:public Schein {int nominal(){return 1000;}};
class ZwanzigMark:public Schein {int nominal(){return 2000;}};
class FuenfzigMark:public Schein {int nominal(){return 5000;}};
class HundertMark:public Schein {int nominal(){return 10000;}};

Z* L[]={new Pfennig, new Zweier, new Fuenfer, new Groschen,
        new Fuenfziger, new Mark, new ZweiMark, new FuenfMark,
	new ZehnMark, new ZwanzigMark, new FuenfzigMark, new HundertMark};

class Saldo {
	int l[12];
public:
	friend ostream& operator << (ostream& o, const Saldo& s)
		{
			if (s.l[0]) o<<s.l[0]<<" Pfennige\n";
			if (s.l[1]) o<<s.l[1]<<" Zweier\n";
			if (s.l[2]) o<<s.l[2]<<" Fuenfer\n";
			if (s.l[3]) o<<s.l[3]<<" Groschen\n";	
			if (s.l[4]) o<<s.l[4]<<" Fuenfziger\n";
			if (s.l[5]) o<<s.l[5]<<" Mark\n";
			if (s.l[6]) o<<s.l[6]<<" ZweiMark\n";
			if (s.l[7]) o<<s.l[7]<<" FuenfMark\n";
			if (s.l[8]) o<<s.l[8]<<" ZehnMark\n";
			if (s.l[9]) o<<s.l[9]<<" ZwanzigMark\n";
			if (s.l[10]) o<<s.l[10]<<" FuenfzigMark\n";
			if (s.l[11]) o<<s.l[11]<<" HundertMark\n";
			return o;
		}

	Saldo (const Geldbetrag& m)
		{	
			int p=m;
			for (int i=0; i<12; ++i) l[i]=0;
			for (int i=0; i<12; i++)
				while (p-L[11-i]->nominal() >=0)
				{
					l[11-i]++;
					p-=L[11-i]->nominal();
				}
		}
			
	operator Geldbetrag()
		{
			int p=0;
			for (int i=0; i<12; i++)
				p+=l[i]*L[i]->nominal();
			return Geldbetrag(p/100, p%100);
		}
	int c(){int c=0; for(int i=0;i<12;++i)c+=l[i]; return c;}
};

int main()
{       int max=0;
	for (int M=0; M<100; ++M)
		for (int P=0; P<100; ++P)
		{
			Geldbetrag G(M,P);
//			cout << G << endl;

			Saldo S(G);
			if (S.c()>=max){max=S.c(); cout<<S.c()<<endl<<G<<endl;}
//			cout<<S<<endl;
//			cout << Saldo(G)<< endl;
			if (G!=Geldbetrag(Saldo(G))) 
				{cout<<G<<" Error\n"; exit(0);}
		}
}

/*

14 Muenzen oder Scheine braucht man, 
um 88,98 DM passend zu bezahlen

*/

			
