#ifndef _BRUCH_H_
#define _BRUCH_H_

#include <iostream>

class Bruch {
	int zaehler, nenner;
	
public:
	Bruch (int z = 0, int n = 1): zaehler(z), nenner(n) {}
	friend Bruch operator+ (const Bruch& r1, const Bruch& r2);
	friend Bruch operator* (const Bruch& r1, const Bruch& r2);
	friend int operator== (const Bruch& r1, const Bruch& r2);
	operator double() const;
	friend std::ostream& operator<< (std::ostream& o, const Bruch& r);
	Bruch& reduce();
};

inline
int ggT(int i, int j)
{
	if (i==j) return i;
	else 
		if (i>j) return ggT(i-j,j);
		else     return ggT(i,j-i);
}

inline
int kgV(int i, int j)
{
	return i*j/ggT(i,j);
}

inline
Bruch operator* (const Bruch& r1, const Bruch& r2)
{
	return Bruch(r1.zaehler*r2.zaehler, r1.nenner*r2.nenner);
}

inline
int operator== (const Bruch& r1, const Bruch& r2)
{
	return r1.zaehler*r2.nenner == r1.nenner*r2.zaehler; 
}

inline
Bruch::operator double() const
{
	return double(zaehler)/nenner; 
}

inline
std::ostream& operator<< (std::ostream& o, const Bruch& r)
{
	return o<<"["<<r.zaehler<<"/"<<r.nenner<<"]"; 
}

inline
Bruch& Bruch::reduce()
{
	int k=ggT(zaehler, nenner);
	zaehler/=k;
	nenner /=k;
	return *this;
}

inline
Bruch operator+ (const Bruch& r1, const Bruch& r2)
{
	int Hn=kgV(r1.nenner, r2.nenner);
	int z1= r1.zaehler*(Hn/r1.nenner);
	int z2= r2.zaehler*(Hn/r2.nenner);
	return Bruch(z1+z2, Hn).reduce();
}

#endif 
