#include <iostream>

using namespace std;

class P {
public:
	virtual int operator[](int)const=0;
	virtual int dim()const =0;
	friend ostream& operator << (ostream& o, const P& p)
	{
		for (int i=0; i<p.dim(); ++i)
			o << p[i] << '\t';
		return o << endl;
	}
};

template <int N>
class Pascal: public P {
	int p[N];
public:
	int operator[](int i)const
	{
		if (i<0 || i>=N) return 0;
		return p[i];
	}

	int dim()const{return N;}

	Pascal() 
	{ 
		Pascal<N-1> P;	
		// cout<<" creating a Pascal<"<<N-1<<">\n";

		for (int i=0; i<N; ++i)
		{
			p[i]=P[i-1]+P[i];
		}
		
	}
};

template <>
class Pascal<1>: public P {
public:
	int operator[](int i)const
	{
		if (i==0) return 1;
		return 0;
	}

	int dim()const{return 1;}
};

int main()
{

	Pascal<1> p1;
	Pascal<2> p2;
	Pascal<3> p3;
	Pascal<4> p4;
	Pascal<5> p5;
	Pascal<6> p6;

	Pascal<33> p33;

	P* Ps[]={&p1,&p2,&p3,&p4,&p5,&p6,&p33};

	for (int i=0; i<7; ++i) cout<<*Ps[i];

}	
