/*
 * 8.cc
 * erlaeutern sie die ausgaben des folgenden programms
 *
 */

#include <iostream>
using namespace std;

class Rational;
Rational operator + (const Rational &, const Rational&);

class Rational {
	int zaehler, nenner;
public:
	Rational (int z = 0, int n = 1): zaehler(z), nenner(n) {}
	friend Rational operator+ (const Rational& r1, const Rational& r2);
	friend Rational operator* (const Rational& r1, const Rational& r2);
	friend int operator== (const Rational& r1, const Rational& r2);
	operator double() const;
	friend ostream& operator<< (ostream& o, const Rational& r);
	Rational& reduce();
};

inline
int ggT(int i, int j)
{
	if (i==j) return i;
	else 
		if (i>j) return ggT(i-j,j);
		else     return ggT(i,j-i);
}

inline
int kgV(int i, int j)
{
	return i*j/ggT(i,j);
}

inline
Rational operator* (const Rational& r1, const Rational& r2)
{
	return Rational(r1.zaehler*r2.zaehler, r1.nenner*r2.nenner);
}

inline
int operator== (const Rational& r1, const Rational& r2)
{
	return r1.zaehler*r2.nenner == r1.nenner*r2.zaehler; 
}

inline
Rational::operator double() const
{
	return double(zaehler)/nenner; 
}

inline
ostream& operator<< (ostream& o, const Rational& r)
{
	return o<<"["<<r.zaehler<<"/"<<r.nenner<<"]"; 
}

inline
Rational& Rational::reduce()
{
	int k=ggT(zaehler, nenner);
	zaehler/=k;
	nenner /=k;
	return *this;
}

inline
Rational operator+ (const Rational& r1, const Rational& r2)
{
	int Hn=kgV(r1.nenner, r2.nenner);
	int z1= r1.zaehler*(Hn/r1.nenner);
	int z2= r2.zaehler*(Hn/r2.nenner);
	return Rational(z1+z2, Hn).reduce();
}


Rational eins=1;
Rational ein_halb (1, 2);
Rational zwei_viertel (2, 4);
Rational ein_drittel (1, 3);
Rational zwei_drittel (2,3);

int main()
{
	cout<<"eins="<<eins<<endl;
	cout<<"ein_halb="<<ein_halb<<endl;
	cout<<"zwei_viertel="<<zwei_viertel<<endl;
	cout<<"ein_drittel="<<ein_drittel<<endl;
	cout<<"zwei_drittel="<<zwei_drittel<<endl;
	cout<<"zwei_viertel.reduce()="<<zwei_viertel.reduce()<<endl;
	cout<<"ein_halb*ein_drittel="<<ein_halb*ein_drittel<<endl;
	cout<<"ein_halb+ein_drittel="<<ein_halb+ein_drittel<<endl;
	cout<<"ein_drittel+zwei_drittel="<<ein_drittel+zwei_drittel<<endl;
	cout<<"double(zwei_drittel)="<<double(zwei_drittel)<<endl;
	if (ein_halb==zwei_viertel) cout<<"ok"<<endl;
}
